#version 430
#extension GL_ARB_separate_shader_objects : enable










struct SComputeInput
{
	uvec3 GlobalThreadID; uvec3 LocalThreadID; uvec3 GroupID;};

layout(std430 ) readonly buffer BStreamInfo
{
	uint StreamInfo[];
} StreamInfo;
layout(std430 ) readonly buffer BGPUSimData
{
	uint GPUSimData[];
} GPUSimData;
layout(std430 ) readonly buffer BCustomSortKeysOffsets
{
	uint CustomSortKeysOffsets[];
} CustomSortKeysOffsets;
layout(std430 ) buffer BOutSortKeys
{
	uint OutSortKeys[];
} OutSortKeys;
layout(std430 ) buffer BOutIndirection
{
	uint OutIndirection[];
} OutIndirection;

layout( std140) uniform UInfo
{
	uint DrawRequest;
} Info;


void ComputeMain( in SComputeInput  cInput  )
{
	uint particleID = cInput.GlobalThreadID.x;
	const uint drawRequest =  Info.DrawRequest ;
	const uint customSortKeyOffset =  CustomSortKeysOffsets.CustomSortKeysOffsets [ drawRequest ] ;

	uint key =  floatBitsToUint( packHalf2x16(vec2 ( uintBitsToFloat(GPUSimData.GPUSimData [customSortKeyOffset + particleID ]) , 0)) ) ;
	const uint signBit = (key >> 15) & 1;
	const uint toggleMask = ((1 << 15) - signBit) | (1 << 15);
	key = key ^ toggleMask;
	if (particleID >=  StreamInfo.StreamInfo [0] )
		key = ~uint(0);

	OutSortKeys.OutSortKeys [ particleID ] = key; ;

	OutIndirection.OutIndirection [ particleID ] = particleID; ;
}

layout(local_size_x = 128, local_size_y = 1, local_size_z = 1) in;
void main()
{
	SComputeInput cInput;
	cInput.GlobalThreadID = gl_GlobalInvocationID;
	cInput.LocalThreadID = gl_LocalInvocationID;
	cInput.GroupID = gl_WorkGroupID;
	ComputeMain(cInput);
}
