#version 430
#extension GL_ARB_separate_shader_objects : enable






struct SVertexInput
{
	int VertexIndex;
	uint InstanceId;
};

layout(location = 0) smooth out vec4 _vout_fragColor;

struct SVertexOutput
{
	vec4 fragColor;
	vec4 VertexPosition;
};

layout( std140) uniform USceneInfo
{
	mat4 ViewProj;
	mat4 View;
	mat4 Proj;
	mat4 InvView;
	mat4 InvViewProj;
	mat4 UserToLHZ;
	mat4 LHZToUser;
	mat4 BillboardingView;
	mat4 PackNormalView;
	mat4 UnpackNormalView;
	vec4 SideVector;
	vec4 DepthVector;
	vec2 ZBufferLimits;
	float Handedness;
} SceneInfo;
layout( std140) uniform UBillboardInfo
{
	vec4 DrawRequest[256];
} BillboardInfo;
layout(std430 ) readonly buffer BIndices
{
	uint Indices[];
} Indices;
layout(std430 ) readonly buffer BVertexPosition0
{
	uint VertexPosition0[];
} VertexPosition0;
layout(std430 ) readonly buffer BVertexPosition1
{
	uint VertexPosition1[];
} VertexPosition1;
layout(std430 ) readonly buffer BVertexPosition2
{
	uint VertexPosition2[];
} VertexPosition2;

layout( std140) uniform UGPUBillboardPushConstants
{
	uint IndicesOffset;
} GPUBillboardPushConstants;
vec4 proj_position( in vec3  position  )
{

	return  (( SceneInfo.ViewProj ) * (vec4(position, 1.0f))) ;
}

void VertexBillboard( in SVertexInput  vInput,  inout SVertexOutput  vOutput, uint particleID  )
{



	const vec4 worldPosDrId =  vec4( uintBitsToFloat(VertexPosition0.VertexPosition0 [ particleID * 4 ]) , uintBitsToFloat(VertexPosition0.VertexPosition0 [( particleID * 4 ) + 1]) , uintBitsToFloat(VertexPosition0.VertexPosition0 [( particleID * 4 ) + 2]) , uintBitsToFloat(VertexPosition0.VertexPosition0 [( particleID * 4 ) + 3]) ) ;

	vec3 worldPos = vec3(0.0, 0.0, 0.0);
	if (vInput.VertexIndex == 0)
		worldPos = worldPosDrId.xyz;
	else if (vInput.VertexIndex == 1)
		worldPos =  vec3( uintBitsToFloat(VertexPosition1.VertexPosition1 [ particleID * 3 ]) , uintBitsToFloat(VertexPosition1.VertexPosition1 [( particleID * 3 ) + 1]) , uintBitsToFloat(VertexPosition1.VertexPosition1 [( particleID * 3 ) + 2]) ) ;
	else if (vInput.VertexIndex == 2)
		worldPos =  vec3( uintBitsToFloat(VertexPosition2.VertexPosition2 [ particleID * 3 ]) , uintBitsToFloat(VertexPosition2.VertexPosition2 [( particleID * 3 ) + 1]) , uintBitsToFloat(VertexPosition2.VertexPosition2 [( particleID * 3 ) + 2]) ) ;


    vOutput.VertexPosition = proj_position(worldPos  );
}

void VertexMain( in SVertexInput  vInput,  out SVertexOutput  vOutput  )
{
	const uint indicesOffset =  GPUBillboardPushConstants.IndicesOffset ;



	const uint particleID =  Indices.Indices [ indicesOffset + vInput.InstanceId ] ;


	float degenerate = 1.0;
	vOutput.fragColor = vec4(1.0, 0.0, 1.0, 1.0);
	VertexBillboard(vInput, vOutput, particleID  );
	vOutput.VertexPosition *= degenerate;
}


void main()
{
	SVertexInput vInput;
	SVertexOutput vOutput;

	vInput.VertexIndex = gl_VertexID;
	vInput.InstanceId = uint(gl_InstanceID);
	vOutput.fragColor = vec4(0, 0, 0, 0);
	VertexMain(vInput, vOutput);
	_vout_fragColor = vOutput.fragColor;
	gl_Position = vOutput.VertexPosition;
}
